// あらかじめ答えを固定。移動先はランダムに決める。
// 1 回も製品が通っていないかつ、両端の製品が停止したことがない、ようなコンベアがあったら無条件に WA にする。

#include <cstdio>
#include <utility>
#include <vector>
#include <iostream>

#include "xrand1.h"
#include "strategy_base.hpp"

struct random1 : public strategy_base {
  XRand rnd;
  std::vector<int> C;
  std::vector<int> passed;

  random1() : rnd(), C(), passed() {
    scanf("%d", &N);
    A.resize(N - 1);
    B.resize(N - 1);
    C.resize(N - 1);
    passed.resize(N - 1, false);
    for (int i = 0; i < N - 1; i++) {
      scanf("%d", &A[i]);
    }
    for (int i = 0; i < N - 1; i++) {
      scanf("%d", &B[i]);
    }
    for (int i = 0; i < N - 1; i++) {
      scanf("%d", &C[i]);
    }

    unsigned long long seed = 0;
    scanf(" 0x%llX", &seed);
    rnd.Reset(seed);
  }

  std::vector<int> Query(std::vector<int> x, std::vector<int> y) override {
    struct edge {
      int to, id;
    };
    std::vector<std::vector<edge>> g(N), rev(N);
    for (int i = 0; i < N - 1; i++) {
      int a = A[i], b = B[i];
      if (C[i] ^ x[i]) {
        std::swap(a, b);
      }
      g[a].push_back({b, i});
      rev[b].push_back({a, i});
    }
    std::vector<int> z(N, 0);
    for (int i = 0; i < N; i++) {
      if (y[i]) {
        if (g[i].empty()) {
          z[i] = 1;
          for (const auto &[to, id] : rev[i]) {
            passed[id] = true;
          }
        } else {
          const auto [to, id] = g[i][rnd.NextInt(0, g[i].size() - 1)];
          z[to] = 1;
          passed[id] = true;
        }
      }
    }
    return z;
  }

  bool Answer(std::vector<int> a) override {
    for (int i = 0; i < N - 1; i++)
      if (!passed[i])
        return false;
    return a == C;
  }
};
